var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var _EChartsElement_instances, _EChartsElement_core, _EChartsElement_eventHandlers, _EChartsElement_eventData, _EChartsElement_init, _EChartsElement_boot;
import { init } from 'echarts/core';
import { Observable } from 'iterable-observer';
import { debounce } from 'lodash';
import { parseDOM } from 'web-utility';
import { ProxyElement } from '../Proxy';
export class EChartsElement extends ProxyElement {
    get renderer() {
        const [_, type] = this.tagName.toLowerCase().split('-');
        return type;
    }
    get options() {
        return __classPrivateFieldGet(this, _EChartsElement_core, "f").getOption();
    }
    constructor() {
        super();
        _EChartsElement_instances.add(this);
        _EChartsElement_core.set(this, void 0);
        _EChartsElement_eventHandlers.set(this, []);
        _EChartsElement_eventData.set(this, []);
        this.handleResize = debounce(() => __classPrivateFieldGet(this, _EChartsElement_core, "f").resize(this.toJSON().resizeOptions));
        this.attachShadow({ mode: 'open' }).append(parseDOM('<div style="height: 100%" />')[0]);
        __classPrivateFieldGet(this, _EChartsElement_instances, "m", _EChartsElement_boot).call(this);
    }
    connectedCallback() {
        var _a;
        this.style.display = 'block';
        __classPrivateFieldGet(this, _EChartsElement_instances, "m", _EChartsElement_init).call(this);
        (_a = globalThis.addEventListener) === null || _a === void 0 ? void 0 : _a.call(globalThis, 'resize', this.handleResize);
    }
    disconnectedCallback() {
        var _a, _b;
        (_a = globalThis.removeEventListener) === null || _a === void 0 ? void 0 : _a.call(globalThis, 'resize', this.handleResize);
        (_b = __classPrivateFieldGet(this, _EChartsElement_core, "f")) === null || _b === void 0 ? void 0 : _b.dispose();
    }
    setOption(data) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!__classPrivateFieldGet(this, _EChartsElement_core, "f")) {
                __classPrivateFieldGet(this, _EChartsElement_eventData, "f").push(data);
                return;
            }
            __classPrivateFieldGet(this, _EChartsElement_core, "f").setOption(data, false, true);
        });
    }
    setProperty(key, value) {
        super.setProperty(key, value);
        this.setOption(this.toJSON());
    }
    listen(event, handler) {
        if (__classPrivateFieldGet(this, _EChartsElement_core, "f"))
            __classPrivateFieldGet(this, _EChartsElement_core, "f").getZr().on(event, handler);
        else
            __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").push([event, handler]);
    }
    onChild(event, selector, handler) {
        if (__classPrivateFieldGet(this, _EChartsElement_core, "f"))
            __classPrivateFieldGet(this, _EChartsElement_core, "f").on(event, selector, handler);
        else
            __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").push([event, handler, selector]);
    }
    forget(event, handler) {
        if (__classPrivateFieldGet(this, _EChartsElement_core, "f"))
            __classPrivateFieldGet(this, _EChartsElement_core, "f").getZr().off(event, handler);
        else {
            const index = __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").findIndex(item => item[0] === event && item[1] === handler && !item[2]);
            if (index > -1)
                __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").splice(index, 1);
        }
    }
    offChild(event, selector, handler) {
        if (__classPrivateFieldGet(this, _EChartsElement_core, "f"))
            __classPrivateFieldGet(this, _EChartsElement_core, "f").off(event, handler);
        else {
            const index = __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").findIndex(item => item[0] === event &&
                item[1] === handler &&
                item[2] === selector);
            if (index > -1)
                __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").splice(index, 1);
        }
    }
}
_EChartsElement_core = new WeakMap(), _EChartsElement_eventHandlers = new WeakMap(), _EChartsElement_eventData = new WeakMap(), _EChartsElement_instances = new WeakSet(), _EChartsElement_init = function _EChartsElement_init() {
    return __awaiter(this, void 0, void 0, function* () {
        var _a = this.toJSON(), { theme, initOptions } = _a, props = __rest(_a, ["theme", "initOptions"]);
        __classPrivateFieldSet(this, _EChartsElement_core, init(this.shadowRoot.firstElementChild, theme, Object.assign(Object.assign({}, initOptions), { renderer: this.renderer })), "f");
        this.setOption(Object.assign({ grid: {} }, props));
        for (const [event, handler, selector] of __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f"))
            if (selector)
                this.onChild(event, selector, handler);
            else
                this.listen(event, handler);
        __classPrivateFieldGet(this, _EChartsElement_eventHandlers, "f").length = 0;
        for (const option of __classPrivateFieldGet(this, _EChartsElement_eventData, "f"))
            this.setOption(option);
        __classPrivateFieldGet(this, _EChartsElement_eventData, "f").length = 0;
    });
}, _EChartsElement_boot = function _EChartsElement_boot() {
    return __awaiter(this, void 0, void 0, function* () {
        var _a, e_1, _b, _c;
        try {
            for (var _d = true, _e = __asyncValues(Observable.fromEvent(this, 'optionchange')), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                _c = _f.value;
                _d = false;
                const { detail } = _c;
                this.setOption(detail);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
};
//# sourceMappingURL=core.js.map